#include "stdafx.h"


#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "transform.h"
#include "process.h"


#include "err.h"
#include "fsx.h"
#include "alloc.h"
#include "bf.h"
#include "etc.h"
#include "deb.h"
#include "trans.h"

#include "str.h"


#include "bmp.h"
#include "asprite.h"


#include "main.h"




filestr xfile;

filestr * loadfile=&xfile;



#define FFCHUNK 8

/* add a new frame to this image                   */
/* size is sizeof corresponding private data array */

os_error * addframe(filestr * file,int * fn,int size)
{
 os_error * err;

 if(file->frames) err=schunk((flex_ptr)&file->frames,
                (file->framen+1)*sizeof(framestr),FFCHUNK*sizeof(framestr));
 else             err=salloc((flex_ptr)&file->frames,FFCHUNK*sizeof(framestr));

// cprintf("file->frames=%x file=%x",file->frames,file);


 if(!err)
 {
  if(size)
  {
   if(file->data) err=schunk((flex_ptr)&file->data,
                                  (file->framen+1)*size,FFCHUNK*size);
   else           err=salloc((flex_ptr)&file->data,FFCHUNK*size);
  }

  if(!err)
  {
   *fn=file->framen;
   file->framen++;
  }
 }
 return(err);
}





static errtag errortable[]=
{
 EMEM,     "{EMEM}",
 EMODE,    "{EMODE}",
 EBADBITS, "{EBADBITS}",
 ERD,      "{ERD}",
 EWR,      "{EWR}",
 ECR,      "{ECR}",
 ENOTTYPE, "{ENOTTYPE}",
 EBADBITS, "{EBADBITS}",

 ELAST ,""
};


static errlink errorlink;





int main(int argc,char * argv[])
{
 os_error * err;
 ATOM       atom;
 int        loaddraw;
 
 if(argc<3)
 {
  err=generror(0,"Syntax: TransBMP <input file> <output file>\r\n");
 }
 else
 { 
  addtranstable(NULL,"Messages.txt");
  adderrortable(errortable,&errorlink);
  
  loaddraw=0;
  
  if(loaddraw)
  {
            err=loadasprite(argv[1],0,0,0);
   if(!err) err=savebmp(loadfile,0,argv[2],0);
  }
  else
  {
            err=loadbmp(argv[1],0,0,0);
   if(!err) err=savespritesub(loadfile,0,argv[2],0,1);
  }
 }

 if(err)
 {
  atom=GlobalAddAtom(err->errmess);
  return((int)atom);
 }

 return(0);
}


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{

 return(main(__argc,__argv));

 USE(hInstance);
 USE(nCmdShow);
 USE(lpCmdLine);
 USE(hPrevInstance);
}
